package lab6;

import COSC3P91.xml.XMLObject;
import COSC3P91.xml.XMLReader;
import java.io.Reader;

public class Department implements XMLObject {
    
    private final String depName;
    private final PersonList depMembers;
    private final DepartmentType depType;
    
    private static XMLReader<Department> reader = null;
    
    public static Department read(Reader source) {
        if (reader==null) {
            reader = new XMLReader();
            reader.setXMLSchema("Department.xsd");
            reader.setXMLNodeConverter(XMLNodeConverterDepartment.getInstace());
        }
        return reader.readXML(source);
    }

    public Department(String depName, PersonList depMembers, DepartmentType depType) {
        this.depName = depName;
        this.depMembers = depMembers;
        this.depType = depType;
    }

    @Override
    public String toXMLString() {
        return "<Department name=\"" + depName +"\" type=\"" + depType +"\">\n" + depMembers.toXMLString() + "\n</Department>";
    }
    
}
