package lab6;

import COSC3P91.xml.XMLNodeConverter;
import static COSC3P91.xml.XMLTools.getChildNodes;
import static COSC3P91.xml.XMLTools.getEnumAttribute;
import static COSC3P91.xml.XMLTools.getStringAttribute;
import org.w3c.dom.Node;

public class XMLNodeConverterDepartment implements XMLNodeConverter<Department> {
    
    private final static XMLNodeConverterDepartment instance = new XMLNodeConverterDepartment();
    
    public static XMLNodeConverterDepartment getInstace() {
        return instance;
    }
    
    private XMLNodeConverterDepartment() {
    }
    
    @Override
    public Department convertXMLNode(Node node) {
        Department result = null;
        if (node.getNodeName().equals("Department")) {
            String depName = getStringAttribute(node,"name");
            DepartmentType depType = (DepartmentType) getEnumAttribute(DepartmentType.class,node,"type");
            PersonList list = XMLNodeConverterPersonList.getInstance().convertXMLNode(getChildNodes(node).get(0));
            result = new Department(depName,list,depType);
        }
        return result;
    }
  
}
